<?php

namespace App\Filament\Imports;

use App\Models\EmployeeMaster;
use Filament\Actions\Imports\ImportColumn;
use Filament\Actions\Imports\Importer;
use Filament\Actions\Imports\Models\Import;

class EmployeeMasterImporter extends Importer
{
    protected static ?string $model = EmployeeMaster::class;

    public static function getColumns(): array
    {
        return [
            ImportColumn::make('plant')
                ->requiredMapping()
                ->relationship()
                ->rules(['required']),
            ImportColumn::make('name'),
            ImportColumn::make('code'),
            ImportColumn::make('department'),
            ImportColumn::make('designation'),
            ImportColumn::make('email')
                ->rules(['email']),
            ImportColumn::make('mobile_number'),
            ImportColumn::make('created_by'),
            ImportColumn::make('updated_by'),
        ];
    }

    public function resolveRecord(): ?EmployeeMaster
    {
        // return EmployeeMaster::firstOrNew([
        //     // Update existing records, matching them by `$this->data['column_name']`
        //     'email' => $this->data['email'],
        // ]);

        return new EmployeeMaster();
    }

    public static function getCompletedNotificationBody(Import $import): string
    {
        $body = 'Your employee master import has completed and ' . number_format($import->successful_rows) . ' ' . str('row')->plural($import->successful_rows) . ' imported.';

        if ($failedRowsCount = $import->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to import.';
        }

        return $body;
    }
}
